#!/bin/bash
#author: Cristiano Rodrigues Siqueira Soares
#descricao: Instala o rclone atualizado
#Revisao:

user=`whoami`

confirmar(){
    echo "╔═══════════════════════════════════════════════════════╗"
    echo "║ Lembre-se de seguir a configuração padrão do rclone!! ║"
    echo "║ NOME: backup                                          ║"
    echo "║ LOCAL: Google Drive                                   ║"
    echo "╚═══════════════════════════════════════════════════════╝"
    read -p "Seguir com a configuração? (s/n) R: " confirmo
    echo " "
}

configrclone(){
    echo "╔═════════════════════════════╗"
    echo "║ Deseja configurar o Rclone? ║"
    echo "║     SIM (1)     NÃO (2)     ║"
    echo "╚═════════════════════════════╝"
    read -p "R: " simounao
    if [[ $simounao == 1 ]];then
        confirmar
        rclone config
    elif [[ $simounao == 2 ]];then
        echo "Ok!"
        sleep 2
    else
        clear
        echo "╔══════════════════════════════╗"
        echo "║ Você digitou uma opção erra! ║"
        echo "╚══════════════════════════════╝"
        sleep 2
        clear
        configrclone
    fi
}

alteracrontab(){
    echo "╔═══════════════════════════╗"
    echo "║ Deseja alterar o crontab? ║"
    echo "║    SIM (1)     NÃO (2)    ║"
    echo "╚═══════════════════════════╝"
    read -p "R: " crontabsimounao
    if [[ $crontabsimounao == 1 ]];then
        sudo vi /etc/crontab
    elif [[ $crontabsimounao == 2 ]];then
        echo "Ok!"
        sleep 2
    else
        clear
        echo "╔══════════════════════════════╗"
        echo "║ Você digitou uma opção erra! ║"
        echo "╚══════════════════════════════╝"
        sleep 2
        clear
        alteracrontab
    fi
}

fim(){
    echo " "
    echo " "
    echo "╔═════════════════════╗"
    echo "║         FIM         ║"
    echo "╚═════════════════════╝"
    echo " "
    exit
}

if [[ $user == "root" ]]; then

    echo "╔═══════════════════════════════════════════════╗"
    echo "║  Iniciando processo de instalação do R-clone. ║"
    echo "╚═══════════════════════════════════════════════╝"
    apt update
    apt -y install curl
    sudo -v ; curl https://rclone.org/install.sh | sudo bash
    echo " "
    echo " "
    echo " "
	sleep 1

    echo "╔════════════════════════════════════════════════════╗"
    echo "║ Criando pastas para processo de backup do R-Clone. ║"
    echo "╚════════════════════════════════════════════════════╝"
    sleep 2
    cd /
    sudo mkdir backup
    echo "╔═════════════════════════════╗"
    echo "║ Pasta backup criada.     [✔]║"
    sleep 1
    sudo mkdir backup/diario
    echo "║ Pasta diario criada.     [✔]║"
    sleep 1
    sudo mkdir backup/diario/Dropbox
    echo "║ Pasta Dropbox criada.    [✔]║"
    echo "╚═════════════════════════════╝"
    sleep 1

    echo "╔══════════════════╗"
    echo "║ Dando permissões ║"
    echo "╚══════════════════╝"
    echo " "
    sleep 2

    if [[ -e /backup/copia.erp.cloud ]];then
        echo "╔═══════════════════════════════════════════════════╗"
        echo "║ Arquivo 'copia.erp.cloud' existe na pasta backup. ║"
        echo "║          Continuando processo de backup!          ║"
        echo "╚═══════════════════════════════════════════════════╝"
        sleep 3
    else
        echo "╔═══════════════════════════════════════════════╗"
        echo "║ Fazendo download do arquivo 'copia.erp.cloud' ║"
        echo "║             para a pasta /backup/             ║"
        echo "╚═══════════════════════════════════════════════╝"
        sleep 3
        cd /backup/
        wget http://download.sigsolucoes.net.br/produtos/crss/txt/copia.erp.cloud
    fi

    chmod 777 /backup/ -R

    if [[ -e /home/caixa ]];then
        chown caixa:caixa /backup/ -R
    elif [[ -e /home/sig ]];then
        chown sig:sig /backup/ -R
    fi

    echo "╔══════════════════════════════════════════════╗"
    echo "║ Alterando arquivo de backup copia.erp.cloud. ║"
    echo "╚══════════════════════════════════════════════╝"
    cd /backup
    grep 'db_password' '/etc/openerp-server.conf' | awk '{print$3}'
    echo "╔═══════════════════════════════════════╗"
    echo "║         PADRDAO DE RESPOSTAS          ║"
    echo "║ Senha do banco: qualquer senha        ║"
    echo "║ Nome do banco: nome_db                ║"
    echo "║ Nome do arquivo: nome_db.dump         ║"
    echo "╚═══════════════════════════════════════╝"

    read -p "Qual a senha do banco?: " senhadobanco
    read -p "Qual o nome do banco?: " nomedobanco
    read -p "Qual o nome do arquivo dump?: " nomedodump

    sed -i "s/senha/$senhadobanco/g" copia.erp.cloud
    sed -i "s/nomebd1/$nomedobanco/g" copia.erp.cloud
    sed -i "s/nomebd2/$nomedodump/g" copia.erp.cloud


	if [[ -e /home/caixa/.config/ ]];then
		cd /home/caixa/.config
		mkdir /home/caixa/.config/rclone
		touch /home/caixa/.config/rclone/rclone.conf
		cd /home/caixa/.config
		chmod 777 rclone/ -R
	elif [[ -e /home/sig/.config/ ]];then
		cd /home/sig/.config
		mkdir /home/sig/.config/rclone
		touch /home/sig/.config/rclone/rclone.conf
		cd /home/sig/.config
		chmod 777 rclone/ -R
	else
		echo "╔═══════════════════════════════════════════════════════╗"
		echo "║ Não existe usuário 'caixa' ou 'sig' neste computador. ║"
		echo "╚═══════════════════════════════════════════════════════╝"
		fim
	fi

    rclone --version
    configrclone #Inicia processo de configuração do R-Clone
    alteracrontab #Abre o crontab para ser adicionado o comando que vai rodar o backup
    fim
else
	clear
	echo " "
    echo "          ╔══════════════════════════════════════════════╗"
    echo "          ║ Execute este aplicatvo como Root, por favor. ║"
    echo "          ╚══════════════════════════════════════════════╝"
	fim
fi
